VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 2  'RequiresTransaction
END
Attribute VB_Name = "Author"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' getAuthors
'
' Returns disconnected recordset with listing of author information
' from authors view
Public Function getAuthors() As ADODB.Recordset

   'Declare object variables for the database connection and recordset
   Dim cn As New Connection
   Dim rs As New Recordset

   ' add error handler
   On Error GoTo HandleError
            
   ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;" & _
                         "uid=sa;pwd=;database=pubs"
   cn.Open
   
   Set rs.ActiveConnection = cn
   rs.Source = "select * from authors_VIEW"
   rs.CursorLocation = adUseClient
      
   rs.Open
   
   Set rs.ActiveConnection = Nothing
   
   cn.Close
   Set getAuthors = rs
   
' print out any error message
HandleError:
    If Err.Number <> 0 Then
       Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Function

' getAuthors2
'
' gets author information and demonstrates several different
' techniques for processing the recordset information for the author -
' also demonstrates using multiple recordsets
Public Sub getAuthors2()
   
   'Declare object variables for the database connection and recordset
   Dim cn As New Connection
   Dim cmnd As New Command
   Dim rs As New Recordset
   Dim fld As Field

   Dim objContext As ObjectContext
   Dim objResponse As Response
   Dim objRequest As Request
   Set objContext = GetObjectContext()
   
   Set objResponse = objContext("Response")
   Set objRequest = objContext("Request")

   ' add error handler
   On Error GoTo HandleError
            
   
   ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;" & _
                         "uid=sa;pwd=;database=pubs"
   cn.Open

   
   ' set parameters for stored procedure
   Set cmnd.ActiveConnection = cn
   cmnd.Parameters.Append cmnd.CreateParameter("titleid", adVarChar, _
                adParamInput, 6, objRequest.Form.Item("titleid"))

   ' set stored procedure
   cmnd.CommandText = "sp_get_title_1"
   cmnd.CommandType = adCmdStoredProc
   
   ' execute sp
   Set rs = cmnd.Execute
   
   ' Write out title info
   objResponse.Write ("<H1>Title</H1>")
   objResponse.Write "<TABLE width=90% align=center cols=2>"

   If Not (rs.EOF) Then
     objResponse.Write "<TR><TD colspan=2>"
     objResponse.Write rs("title")
     objResponse.Write "</TD></TR><TR><TD>"
     objResponse.Write rs("type")
     objResponse.Write "</TD><TD>"
     objResponse.Write rs("pub_name")
     objResponse.Write "</TD></TR><TR><TD>"
     objResponse.Write rs("price")
     objResponse.Write "</TD><TD>"
     objResponse.Write rs("pubdate")
     objResponse.Write "</TD></TR><TR><TD colspan=2>"
     objResponse.Write rs("notes")
   End If
   objResponse.Write "</TABLE>"
   
   ' get next record set, write out royalty schedule
   Set rs = rs.NextRecordset
   
   objResponse.Write ("<H3>Royality Schedule</H3>")
   objResponse.Write "<TABLE width=90% align=center cols=3>"

   With objResponse
    Do While Not rs.EOF
         .Write "<TR><TD>"
         .Write rs("lorange")
         .Write "</TD><TD>"
         .Write rs("hirange")
         .Write "</TD><TD>"
         .Write rs("royalty")
         .Write "</TR>"
         rs.MoveNext
      Loop
      
    .Write "</TABLE>"

   ' get authors
    Set rs = rs.NextRecordset
      
    .Write "<H3>Author's Name</H3>"
    .Write "<TABLE width=90% align=center>"
      
    Do While Not rs.EOF
     .Write "<TR>"
     For Each fld In rs.Fields
       .Write "<TD>"
       .Write fld.Value
       .Write "</TD>"
      Next fld
      .Write "</TR>"
      rs.MoveNext
    Loop
    .Write "</TABLE>"
    
   End With

   cn.Close
   
   Exit Sub
' print out any error message
HandleError:
    If Err.Number <> 0 Then
       Err.Raise Err.Number, Err.Source, Err.Description
    End If
   
End Sub

' addAuthor
'
' Adds a new author
' using MTS transactions to commit or rollback changes
Public Sub addAuthor()

   'Declare object variables for the database connection and recordset
   Dim cn As Connection
   Dim rs As Recordset
       
   ' get object context
   Dim objContext As ObjectContext
   Dim objRequest As Request
   Dim objResponse As Response
   
   Set objContext = GetObjectContext()
   Set objRequest = objContext("Request")
   Set objResponse = objContext("Response")
   
   ' add error handler
   On Error GoTo HandleError
       
   Set cn = objContext.CreateInstance("ADODB.Connection")
   
    ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;" & _
                         "uid=sa;pwd=;database=pubs"
   cn.Open
      
   ' setup record set - authors table
   Set rs = objContext.CreateInstance("ADODB.Recordset")

   rs.Open "authors", cn, adOpenKeyset, adLockOptimistic
   
   ' access and set values
   rs.AddNew
   Dim fld As Field
   For Each fld In rs.Fields
      fld.Value = objRequest.Form.Item(fld.Name)
   Next fld
   
   ' update record, close connection, complete transaction
   rs.Update
   cn.Close
   objContext.SetComplete

HandleError:
    If Err.Number <> 0 Then
       objContext.SetAbort
       Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Sub

' getSpecificAuthor
'
' retrieves a specific author based on author ID
' returns a disconnected recordset with the information
Public Function getSpecificAuthor() As Recordset

   'Declare object variables for the database connection and recordset
   Dim cn As New Connection
   Dim rsAuthors As Recordset
       
   ' get object context
   Dim objContext As ObjectContext
   Dim objRequest As Request
   Dim objSession As Session
   
   Set objContext = GetObjectContext()
   ' add error handler
   On Error GoTo HandleError
   
   Set objRequest = objContext.Item("Request")
   Set objSession = objContext.Item("Session")
   
     ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
         
   ' setup record set - authors table
   Set rsAuthors = New ADODB.Recordset
   
  
   Dim strCommand As String
   strCommand = "select * from authors where au_id = '"
   strCommand = strCommand & objRequest.Form("authors") & "'"
   
   Set rsAuthors.ActiveConnection = cn
   rsAuthors.CursorType = adOpenKeyset
   rsAuthors.CursorLocation = adUseClient
   rsAuthors.LockType = adLockOptimistic
   
   rsAuthors.Open strCommand
   
   ' disconnect recordset
   Set rsAuthors.ActiveConnection = Nothing
   cn.Close
   
   ' store recordset in session object
   ' only do this if you have run ado15.reg, to set the
   ' threading model on the ADO objects to both threaded
   
   Set objSession.Contents("objauthor") = rsAuthors
   Set getSpecificAuthor = rsAuthors

   
HandleError:
    If Err.Number <> 0 Then
       objContext.SetAbort
       Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Function

' updateAuthor
'
' Updates the author record
' Accesses a disconnected recordset stored as a Session object
' reconnects it to the database and uses it
' to compare before and after values - only changed values are updated
Public Sub updateAuthor()

   'Declare object variables for the database connection and recordset
   Dim cn As Connection
   Dim rsAuthors As Recordset
       
   ' get object context
   Dim objContext As ObjectContext
   Dim objRequest As Request
   Dim objSession As Session
   Dim objResponse As Response
   
   Set objContext = GetObjectContext()
   Set objRequest = objContext("Request")
   Set objSession = objContext("Session")
   Set objResponse = objContext("Response")
   
   ' add error handler
   On Error GoTo HandleError
       
   Set cn = objContext.CreateInstance("ADODB.Connection")
   
    ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
      
   Set rsAuthors = objSession.Contents("objauthor")
   
   ' reconnect disconnected recordset
   Set rsAuthors.ActiveConnection = cn
   
   ' access and set values
   Dim fld As Field
   For Each fld In rsAuthors.Fields
     If CStr(fld.Value) <> objRequest.Form.Item(fld.Name) Then
       objResponse.Write (fld.Value & " ")
       fld.Value = objRequest.Form.Item(fld.Name)
       objResponse.Write (objRequest.Form.Item(fld.Name) & "<p>")
      End If
   Next fld
   
   rsAuthors.Update
  
   Set objSession("objauthor") = Nothing
   
   cn.Close
   objContext.SetComplete

HandleError:
    If Err.Number <> 0 Then
       rsAuthors.CancelUpdate
    Set objSession("objauthor") = Nothing
       objContext.SetAbort
       Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Sub

' deleteauthor
'
' method deletes specific author
' using MTS transactions to commit or rollback the change
Public Sub deleteAuthor()

   'Declare object variables for the database connection and recordset
   Dim cn As Connection
   Dim cmnd As Command
   Dim rs As Recordset
   
   ' declare variables for context and request object
   Dim objRequest As Request
   Dim objContext As ObjectContext
   
   Set objContext = GetObjectContext()
   
   ' create ASP objects
   Set objRequest = objContext.Item("Request")
   
   On Error GoTo HandleError

   Set cn = objContext.CreateInstance("ADODB.Connection")
   
   ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
   
   ' set connection
   Set cmnd = objContext.CreateInstance("ADODB.Command")
   Set cmnd.ActiveConnection = cn

   ' set parameters for stored procedure
   cmnd.Parameters.Append cmnd.CreateParameter("au_id_1", _
   adVarChar, adParamInput, 11, objRequest.Form.Item("authors"))

   ' set stored procedure
   cmnd.CommandText = "sp_delete_authors_1"
   cmnd.CommandType = adCmdStoredProc
   
   ' execute sp
   Set rs = cmnd.Execute
   
   cn.Close
   objContext.SetComplete
HandleError:
    If Err.Number <> 0 Then
        objContext.SetAbort
        Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Sub

