VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 2  'RequiresTransaction
END
Attribute VB_Name = "Publisher"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' getPublishers
'
' returns disconnected recordset with publisher info
Public Function getPublishers() As ADODB.Recordset

   'Declare object variables for the database connection and recordset
   Dim cn As New Connection
   Dim rs As New Recordset

   ' add error handler
   On Error GoTo HandleError
            
   ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
   
   Set rs.ActiveConnection = cn
   rs.Source = "select pub_id, pub_name from publishers"
   rs.CursorLocation = adUseClient
   
   rs.Open
   
   'disconnect recordset
   Set rs.ActiveConnection = Nothing
   cn.Close
   
   Set getPublishers = rs
   
' print out any error message
HandleError:
    If Err.Number <> 0 Then
       Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Function

' deletePublisher
'
' deletes specific publisher
' using MTS to handle commit and rollback transactions
Public Sub deletePublisher()

   'Declare object variables for the database connection and recordset
   Dim cn As Connection
   Dim cmnd As Command
   Dim rs As Recordset
   
   Dim objContext As ObjectContext
   Dim objRequest As Request
   
   Set objContext = GetObjectContext()
   
   ' create ASP objects
   Set objRequest = objContext.Item("Request")
   
   On Error GoTo HandleError

   ' connect to database
   Set cn = objContext.CreateInstance("ADODB.Connection")
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
   
   ' set connection
   Set cmnd = objContext.CreateInstance("ADODB.Command")
   Set cmnd.ActiveConnection = cn

   ' set parameters for stored procedure
   cmnd.Parameters.Append cmnd.CreateParameter("pub_id_1", _
   adVarChar, adParamInput, 4, objRequest.Form.Item("publishers"))

   ' set stored procedure
   cmnd.CommandText = "sp_delete_publishers_1"
   cmnd.CommandType = adCmdStoredProc
   
   ' execute sp
   Set rs = cmnd.Execute
   
   cn.Close
   
   objContext.SetComplete
HandleError:
    If Err.Number <> 0 Then
        objContext.SetAbort
        Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Sub

' addPublisher
'
' Uses MTS to handle transaction commit and rollback
Public Sub addPublisher()

   'Declare object variables for the database connection and recordset
   Dim cn As Connection
   Dim rs As Recordset
       
   ' get object context
   Dim objContext As ObjectContext
   Dim objRequest As Request
   Dim objResponse As Response
   
   Set objContext = GetObjectContext()
   Set objRequest = objContext("Request")
   Set objResponse = objContext("Response")
   
   ' add error handler
   On Error GoTo HandleError
       
    ' connect to database
   Set cn = objContext.CreateInstance("ADODB.Connection")
   cn.ConnectionString = "driver={SQL Server};server=FLAME;" & _
                         "uid=sa;pwd=;database=pubs"
   cn.Open
      
   ' setup record set - publishers table
   Set rs = objContext.CreateInstance("ADODB.Recordset")

   rs.Open "publishers", cn, adOpenKeyset, adLockOptimistic
   
   ' access and set values
   rs.AddNew
   Dim fld As Field
   For Each fld In rs.Fields
      fld.Value = objRequest.Form.Item(fld.Name)
   Next fld
   
   rs.Update
   
   cn.Close
   
   objContext.SetComplete

HandleError:
    If Err.Number <> 0 Then
       objContext.SetAbort
       Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Sub

' getSpecificPublisher
'
' returns disconnected recordset of publisher
' also assigned recordset to Session object for
' value checking with update
Public Function getSpecificPublisher() As Recordset

   'Declare object variables for the database connection and recordset
   Dim cn As New Connection
   Dim rsPublishers As New Recordset
       
   ' get object context
   Dim objContext As ObjectContext
   Dim objRequest As Request
   Dim objSession As Session
   
   Set objContext = GetObjectContext()
   Set objRequest = objContext("Request")
   Set objSession = objContext("Session")
   
   ' add error handler
   On Error GoTo HandleError
   
     ' connect to database
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
               
   Dim strCommand As String
   strCommand = "select * from publishers where pub_id = '"
   strCommand = strCommand & objRequest.Form("publishers") & "'"
   
   Set rsPublishers.ActiveConnection = cn
   rsPublishers.CursorType = adOpenKeyset
   rsPublishers.LockType = adLockPessimistic
   rsPublishers.CursorLocation = adUseClient
   
   rsPublishers.Open strCommand
   
   ' disconnect recordset
   Set rsPublishers.ActiveConnection = Nothing
   
   cn.Close
   
   ' assign disconnected recordset to Session object
   ' only do this is ADO objects have been set to both threaded
   ' by running the ado15fre.reg file
   Set objSession.Contents("objpublisher") = rsPublishers
   
   Set getSpecificPublisher = rsPublishers

HandleError:
    If Err.Number <> 0 Then
       objContext.SetAbort
       Err.Raise Err.Number, Err.Source, Err.Description
    End If


End Function

' updatePublisher
'
' updates publisher
' uses MTS transactions to handle commits and rollbacks
' accesses disconnected recordset from session object to check for changes
Public Sub updatePublisher()

   'Declare object variables for the database connection and recordset
   Dim cn As Connection
   Dim rsPublishers As Recordset
       
   ' get object context
   Dim objContext As ObjectContext
   Dim objRequest As Request
   Dim objSession As Session
   Dim objResponse As Response
   
   Set objContext = GetObjectContext()
   Set objRequest = objContext("Request")
   Set objSession = objContext("Session")
   Set objResponse = objContext("Response")
   
   ' add error handler
   On Error GoTo HandleError
       
    ' connect to database
   Set cn = objContext.CreateInstance("ADODB.Connection")
   cn.ConnectionString = "driver={SQL Server};server=FLAME;uid=sa;pwd=;database=pubs"
   cn.Open
   
   ' get disconnected recordset
   Set rsPublishers = objSession.Contents("objpublisher")
   
   ' access and set values
   Dim fld As Field
   For Each fld In rsPublishers.Fields
     If CStr(fld.Value) <> objRequest.Form.Item(fld.Name) Then
       objResponse.Write (fld.Value & " ")
       fld.Value = objRequest.Form.Item(fld.Name)
       objResponse.Write (objRequest.Form.Item(fld.Name) & "<p>")
      End If
   Next fld
   
   ' reconnect recordset and update
   Set rsPublishers.ActiveConnection = cn
   rsPublishers.Update
  
   Set objSession("objpublishers") = Nothing
   
   cn.Close
   objContext.SetComplete

HandleError:
    If Err.Number <> 0 Then
       rsPublishers.CancelUpdate
    Set objSession("objauthor") = Nothing
       objContext.SetAbort
       Err.Raise Err.Number, Err.Source, Err.Description
    End If

End Sub
