// cssp.cpp : Implementation of Ccssp
#include "stdafx.h"
#include "Dhtml2.h"
#include "cssp.h"


/////////////////////////////////////////////////////////////////////////////
// Ccssp

STDMETHODIMP Ccssp::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_Icssp,
	};
	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}


STDMETHODIMP Ccssp::MoveLeft(BSTR bstrObject, int iBrowser, BSTR bstrValue, BSTR *pbstrDHTML)
{

	HRESULT hr = S_OK;

	// to work with header
	CComBSTR bstrHeader("");
	if (!bstrHeader)
		return CTL_E_OUTOFMEMORY;

	// if browser type of 1 - IE
	if (iBrowser == 1) {
		bstrHeader=bstrObject;
		bstrHeader+=".style.top=";
		bstrHeader+=bstrValue;
	}
	else if (iBrowser == 2) { // Navigator
		bstrHeader = "document."; 
		bstrHeader+=bstrObject;
		bstrHeader+=".top=";
		bstrHeader+=bstrValue;
	}
	else {
		hr = CTL_E_ILLEGALFUNCTIONCALL;
		
		LPCOLESTR lpError = L"An incorrect parameters was passed for browser";
		return AtlReportError(CLSID_cssp,lpError,IID_Icssp,hr);
		
	}

	// assign to return variable, set CComBSTR m_str to null
	*pbstrDHTML = bstrHeader.Detach();

	return hr;
}

STDMETHODIMP Ccssp::MoveTop(BSTR bstrObject, int iBrowser, BSTR bstrValue, BSTR *pbstrDHTML)
{
	// to work with header
	CComBSTR bstrHeader("");
	if (!bstrHeader)
		return E_OUTOFMEMORY;

	// if browser type of 1 - IE
	if (iBrowser == 1) {
		bstrHeader=bstrObject;
		bstrHeader+=".style.top=";
		bstrHeader+=bstrValue;
	}
	else { // Navigator
		bstrHeader = "document."; 
		bstrHeader+=bstrObject;
		bstrHeader+=".top=";
		bstrHeader+=bstrValue;
	}

	// assign to return variable, set CComBSTR m_str to null
	*pbstrDHTML = bstrHeader.Detach();

	return S_OK;
}

STDMETHODIMP Ccssp::Hide(BSTR bstrObject, int iBrowser, BSTR *pbstrDHTML)
{
	// to work with header
	CComBSTR bstrHeader("");
	if (!bstrHeader)
		return E_OUTOFMEMORY;

	// if browser type of 1 - IE
	if (iBrowser == 1) {
		bstrHeader=bstrObject;
		bstrHeader+=".style.visibility='hidden'";
	}
	else { // Navigator
		bstrHeader = "document."; 
		bstrHeader+=bstrObject;
		bstrHeader+=".visibility='hidden'";
	}

	// assign to return variable, set CComBSTR m_str to null
	*pbstrDHTML = bstrHeader.Detach();

	return S_OK;
}

STDMETHODIMP Ccssp::Show(BSTR bstrObject, int iBrowser, BSTR *pbstrDHTML)
{
	// to work with header
	CComBSTR bstrHeader("");
	if (!bstrHeader)
		return E_OUTOFMEMORY;

	// if browser type of 1 - IE
	if (iBrowser == 1) {
		bstrHeader=bstrObject;
		bstrHeader+=".style.visibility='inherit'";
	}
	else { // Navigator
		bstrHeader = "document."; 
		bstrHeader+=bstrObject;
		bstrHeader+=".visibility='inherit'";
	}

	// assign to return variable, set CComBSTR m_str to null
	*pbstrDHTML = bstrHeader.Detach();

	return S_OK;
}
