// mytest.cpp : Implementation of Cmytest
#include "stdafx.h"
#include "MTSAppliction.h"
#include "mytest.h"

/////////////////////////////////////////////////////////////////////////////
// Cmytest

HRESULT Cmytest::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   if (FAILED(hr))
       return hr;


   // get Application property
   bstrObj = "Application";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IApplicationObject, 
                     (void**)&m_piApplication );

   return hr;
} 

BOOL Cmytest::CanBePooled()
{
	return FALSE;
} 

void Cmytest::Deactivate()
{
   // release pointer refs to built-in ASP objects
   m_piResponse.Release();
   m_piApplication.Release();

   // release ObjectContext - generated code
   m_spObjectContext.Release();
} 


STDMETHODIMP Cmytest::thetest()
{
   HRESULT hr = S_OK;
   CComBSTR bstrValue("testers");
   CComVariant vtOut;
   CComVariant vtPara = "<P>";

   // get the application object value directly
   hr = m_piApplication->Lock();
   hr = m_piApplication->get_Value(bstrValue, &vtOut);

   // if failure, return
   if (FAILED(hr))
     return hr;

   // write out current value
   m_piResponse->Write(vtOut);
   m_piResponse->Write(vtPara);
   
      // add new value to application object
   vtOut = OLESTR("secondvalue");
   hr = m_piApplication->put_Value(bstrValue, vtOut);

   // unlock
   hr = m_piApplication->UnLock();

   // Get the Contents Collection
   CComPtr<IVariantDictionary> piVariantVariables;
   hr = m_piApplication->get_Contents(&piVariantVariables);

   // if failure, return
   if (FAILED(hr))
     return hr;

   CComVariant vtIn(OLESTR("MyInfo"));

   // Get the item from the Contents collection
   hr = piVariantVariables->get_Item(vtIn, &vtOut);

   // again, check for failure
   if (FAILED(hr))
     return hr;

   // write value out
   m_piResponse->Write(vtOut);
   m_piResponse->Write(vtPara);

   // change value
   vtOut = OLESTR("newvalue");
   hr = piVariantVariables->put_Item(vtIn, vtOut);


   return S_OK;
}
