// mytest.cpp : Implementation of Cmytest
#include "stdafx.h"
#include "OLEDBTwo.h"
#include "mytest.h"

/////////////////////////////////////////////////////////////////////////////
// Cmytest

HRESULT Cmytest::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );


   return hr;
} 

BOOL Cmytest::CanBePooled()
{
	return FALSE;
} 

void Cmytest::Deactivate()
{
   // release pointer refs to built-in ASP objects
   m_piResponse.Release();

   m_spObjectContext.Release();
} 


STDMETHODIMP Cmytest::test()
{
    // variables
	HRESULT		hr = S_OK;

    CDataSource connection;
    CSession session;
    CTable<CAccessor<CdboauthorsAccessor> > authors;

    CComVariant vbreak(OLESTR("<p>"));


    // Define the DB Property Set
	CDBPropSet	dbinit(DBPROPSET_DBINIT);

    // Set the connection properties
	dbinit.AddProperty(DBPROP_AUTH_PERSIST_SENSITIVE_AUTHINFO, false);
	dbinit.AddProperty(DBPROP_AUTH_USERID, OLESTR("sa"));
	dbinit.AddProperty(DBPROP_INIT_CATALOG, OLESTR("pubs"));
	dbinit.AddProperty(DBPROP_INIT_DATASOURCE, OLESTR("FLAME"));
	dbinit.AddProperty(DBPROP_INIT_LCID, (long)1033);
	dbinit.AddProperty(DBPROP_INIT_PROMPT, (short)4);


    // initialize the database connection
	connection.Open(_T("SQLOLEDB.1"), &dbinit);
	if (FAILED(hr))
			return hr;

    // open the session
    session.Open(connection);

    // open the rowset
    authors.Open(session, "dbo.authors");

    // move through the records and output last name
    authors.MoveFirst();

    while (authors.MoveNext() == S_OK) {
        CComVariant vt(authors.m_aulname);
        m_piResponse->Write(vt);
        m_piResponse->Write(vbreak);
    }


	return hr;
}
