// Advanced.cpp : Implementation of CAdvanced
#include "stdafx.h"
#include "Ctest2APP.h"
#include "Advanced.h"

#include "Game.h"
/////////////////////////////////////////////////////////////////////////////
// CAdvanced

HRESULT CAdvanced::Activate()
{
   HRESULT hr = S_OK;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // generated code
	hr = GetObjectContext(&m_spObjectContext);
   if (FAILED(hr))
      return hr;

   // add in code to get built-in objects
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   return hr;
} 

BOOL CAdvanced::CanBePooled()
{
	return FALSE;
} 

void CAdvanced::Deactivate()
{
   // release pointer refs to built-in ASP objects
   m_piResponse.Release();

	m_spObjectContext.Release();
} 


STDMETHODIMP CAdvanced::set_info(BSTR name)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// write object to file 
	try {

	  // file name
	  char* pFileName = "e:\\test1.dat";

	  // open file using text type, create, write modes, and exclusive share
	  CStdioFile stdFile( pFileName, CFile::modeCreate | CFile::modeWrite | 
		  CFile::shareExclusive | CFile::typeText);    

	  // if successful on opening file, write out parameter
	  CString bstrName = name;
	  stdFile.WriteString(bstrName);
	  stdFile.Close();
	  }

	// error handling
	catch (CFileException *e) {

	  // write out error to returned Web page
      TCHAR   szError[255];
 	  e->GetErrorMessage(szError, 255);
	  CComVariant vt = CComVariant(szError);
	  m_piResponse->Write(vt);
	  }
	return S_OK;
}

// access string in file and return
STDMETHODIMP CAdvanced::get_info(BSTR *pbstrName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// read object from file 
	try {

	  // file name
	  char* pFileName = "e:\\test1.dat";
  	  CString strName;

	  // create file object and open file for read
	  CStdioFile stdFile( pFileName, CFile::modeRead | CFile::typeText);    

	  // read string, close file and return string
	  stdFile.ReadString(strName);
	  stdFile.Close();
	  CComBSTR bstrName(strName);
	  *pbstrName = bstrName.Detach();
	}

	// error handling
	catch (CException *e) {

	  // write out error to returned Web age
      TCHAR   szError[255];
 	  e->GetErrorMessage(szError, 255);
	  CComVariant vt = CComVariant(szError);
	  m_piResponse->Write(vt);
	  }
	return S_OK;

}


STDMETHODIMP CAdvanced::set_score(BSTR name, int score, int time)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState())

    // create new version of Game class
    CGame *m_game = new CGame();

    // set information
    m_game->m_date = CTime::GetCurrentTime();
    m_game->m_gametime = time;
    m_game->m_name = name;
    m_game->m_score = score;

    // serialize object to file  
    CFile f;
    CFileException e;
    char* pFileName = "e:\\test.dat";

    // open file, check for error
    if( !f.Open( pFileName, CFile::modeCreate | CFile::modeWrite | 
        CFile::shareExclusive, &e ) )   
    {
        CComVariant vt(OLESTR("Could not Store Game Results"));
        m_piResponse->Write(vt);
    }
    else {

        // serialize the object
        CArchive archive(&f, CArchive::store);
        m_game->Serialize(archive);
        archive.Close();
        f.Close();
    }
    return S_OK;
}

STDMETHODIMP CAdvanced::get_score(VARIANT *score, VARIANT *time, BSTR *pbstrName)
{
   AFX_MANAGE_STATE(AfxGetStaticModuleState())

   // create new version of CGame class
   CGame *m_game = new CGame();

	CFile f;
	CFileException e;
	char* pFileName = "e:\\test.dat";

	// open file and check for error
	if( !f.Open( pFileName, CFile::modeRead, &e ) )   
	{

		CComVariant vt(OLESTR("Could not access Game Results"));
		m_piResponse->Write(vt);
	}
	else {

		// restore object state
		CArchive archive(&f, CArchive::load);
		m_game->Serialize(archive);
	
		// return values as Variants
		CComVariant *vtScore = new CComVariant(m_game->m_score);
		vtScore->Detach(score);
		CComVariant *vtGametime = new CComVariant(m_game->m_gametime);
		vtGametime->Detach(time);
		m_game->m_name.AllocSysString();

		// return name as BSTR
		*pbstrName = m_game->m_name.SetSysString(pbstrName);
	}
	return S_OK;
}


// serialization process, run on separate worker thread
UINT MyThreadProc( LPVOID pParam ){  
	
    CGame* pGame = (CGame*)pParam;

    // if pGame is not valid return with error condition   
    if (pGame == NULL ||        
        !pGame->IsKindOf(RUNTIME_CLASS(CGame)))
    return 1;   
	
    // serialize object to file  
    CFile f;
    CFileException e;
    char* pFileName = "e:\\test.dat";

    // open file, check for erro
    if( !f.Open( pFileName, CFile::modeCreate | CFile::modeWrite 
        | CFile::shareExclusive, &e ) )   
    {
        return 1;
    }
    else {

        // serialize the object
        CArchive archive(&f, CArchive::store);
        pGame->Serialize(archive);
        archive.Close();
        f.Close();
    }
    return 0;   // thread completed successfully}
}

STDMETHODIMP CAdvanced::set_extended_score(BSTR name, int score, int time)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState())

    // create new version of Game class
    CGame *m_game = new CGame();

    // set information
    m_game->m_date = CTime::GetCurrentTime();
    m_game->m_gametime = time;
    m_game->m_name = name;
    m_game->m_score = score;

    // begin thread and return
    AfxBeginThread(MyThreadProc, m_game);
    return S_OK;

}
